<template>
  <div>
    <div class="btn-action-container">
      <img
        :src="asset('images/ui_elements/ic_edit.png')"
        alt="icon info"
        class="btn-action"
        @click="showModal()"
      >
    </div>
    <b-modal
      id="modal1"
      hide-footer
      hide-header
      centered
      ref="thisModal"
      class="border-0"
      size="600"
    >
      <div class="container" v-if="user">
        <div class="row mb-2">
          <div class="col-md-6">
            <h5>Edit User</h5>
          </div>
          <div class="col-md-6">
            <img
              :src="asset(`images/ui_elements/ic_close.png`)"
              style="width:25px"
              @click="hideModal"
              class="float-right"
            >
          </div>
        </div>
        <div class="row">
          <div class="col-md-12">
            <form class="form-material" @submit.prevent="submitForm">
              <div class="form-group">
                <label>Channel User Id</label>
                <input type="text" class="form-control" readonly v-model="user.channel_user_id">
              </div>
              <div class="form-group">
                <label>Email address</label>
                <input
                  type="email"
                  class="form-control"
                  name="email"
                  v-validate="'required'"
                  placeholder="Enter email"
                  v-model="user.email"
                >
                <small class="text-danger">{{ errors.first('email') }}</small>
              </div>
              <div class="form-group">
                <label>Name</label>
                <input
                  type="text"
                  class="form-control"
                  name="name"
                  v-validate="'required'"
                  placeholder="Enter Name"
                  v-model="user.name"
                >
                <small class="text-danger">{{ errors.first('name') }}</small>
              </div>
              <div class="form-group">
                <label>Nickname</label>
                <input
                  type="text"
                  class="form-control"
                  name="nickname"
                  v-validate="'required'"
                  placeholder="Enter nickname"
                  v-model="user.nickname"
                >
                <small class="text-danger">{{ errors.first('nickname') }}</small>
              </div>
              <div class="form-group">
                <label>Phone</label>
                <input
                  type="text"
                  class="form-control"
                  name="phone"
                  v-validate="'numeric'"
                  placeholder="Enter Phone"
                  v-model="user.phone"
                >
                <small class="text-danger">{{ errors.first('phone') }}</small>
              </div>

              <div class="form-group">
                <label>Gender</label>
                <select name="gender" class="form-control" v-model="user.gender">
                  <option value="m">Male</option>
                  <option value="f">Female</option>
                </select>
              </div>

              <div class="form-group row">
                <div class="col-md-6">
                  <div class="form-check">
                    <input
                      class="form-check-input"
                      type="checkbox"
                      v-model="user.email_verified_at"
                      id="emailVerified"
                    >
                    <label class="form-check-label" for="emailVerified">Email Verified</label>
                  </div>
                </div>
                <div class="col-md-6">
                  <input
                    class="form-check-input"
                    type="checkbox"
                    v-model="user.phone_verified_at"
                    id="phoneVerified"
                  >
                  <label class="form-check-label" for="phoneVerified">Phone Verified</label>
                </div>
              </div>

              <div class="form-group">
                <label>Created At</label>
                <input type="text" class="form-control" v-model="user.created_at" readonly>
              </div>
              <button type="submit" class="btn btn-primary form-control capsule">
                <span v-if="loading">
                  Updating
                  <i class="fas fa-circle-notch fa-spin"></i>
                </span>
                <span v-else>Save</span>
              </button>
            </form>
          </div>
        </div>
      </div>
    </b-modal>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
import * as httpHelper from "@/helpers/httpHelper";

export default {
  data() {
    return {
      loading: false
    };
  },
  props: ["user"],
  methods: {
    hideModal() {
      this.$refs.thisModal.hide();
    },
    showModal() {
      this.$emit("show");
      this.$refs.thisModal.show();
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          this.loading = true;
          let response = await this.$axios.put(
            process.env.MIX_APP_URL +
              `/api/${this.$store.getters.appId.hashed}/user/${this.user.id}`,
            { ...this.user }
          );

          httpHelper.successToast(this, response.data.message);
          this.hideModal();
          EventBus.$emit("refreshTable");
        } catch (error) {
          httpHelper.errorToast(this, error);
        }
      }
      this.loading = false;
    }
  }
};
</script>
<style lang="scss">
</style>
